function [xs, ys] = bb_pointsRectify(xs, ys, w, h, patchSizeX, patchSizeY)
% rectify the point xs(:) and ys(:) so that 
% 1) inside the rectangle [1, 1, w, h]
% 2) one can extract a patch with size at least [patchSizeX, patchSizeY] on it.
if ~exist('patchSizeY', 'var')
    patchSizeY = patchSizeX;
end;
% patchSize should be odd number;
sideX = floor(patchSizeX / 2);
sideY = floor(patchSizeY / 2);

xs = max(xs, sideX + 1);
ys = max(ys, sideY + 1);
xs = min(xs, w - sideX);
ys = min(ys, h - sideY);