function [mask, I, J] = bb_toMask(bbox, theSize, needLogical)
if exist('needLogical', 'var') && needLogical
    mask = repmat(false, [theSize(2), theSize(1)]);
    mask(bbox(2):bbox(4), bbox(1):bbox(3)) = true;
    if nargout > 1
        [J, I] = meshgrid(bbox(1):bbox(3), bbox(2):bbox(4));
        I = I(:);
        J = J(:);
    end;
else
    [J, I] = meshgrid(bbox(1):bbox(3), bbox(2):bbox(4));
    if (max(I(:)) > theSize(2) || max(J(:)) > theSize(1))
        fprintf(1, 'bbox out of bound!');
    end;
    mask = sub2ind([theSize(2), theSize(1)], I(:), J(:));
    I = I(:);
    J = J(:);
end;