function [blockx, blocky, estAllPs, closestPatchesAll, bFine] = exp_multistage_2(img, rectifieds, options1, options2, bFine)
if length(size(rectifieds)) == 4
    [m, n, nChannel, nFrame] = size(rectifieds);
else
    [m, n, nFrame] = size(rectifieds);
end;
if ~exist('options1', 'var')
    options1 = [];
end;
if ~exist('options2', 'var')
    options2 = [];
end;
% resizeRatio = 0.125; % for water data, it seems to be ok. 
options1 = argutil_setdefaults(options1, 'xfrac', 4, 'yfrac', 2, 'alpha', 500, 'nC', 40);

% we use fine bases, which is produced by random gaussian and pca.

if ~exist('bFine', 'var')
    bFine = buildBases(round(m / options1.yfrac), round(n / options1.xfrac), options1.nC, options1.alpha);
end;
[blockx, blocky, estAllPs, closestPatchesAll] = exp_patch(img, rectifieds, bFine, options1, options2);