function [blockx, blocky, estAllPs, closestPatchesAll] = exp_patch(img, frames, b, optionsPartition, options)
if length(size(frames)) == 4
    [m, n, nChannel, nFrame] = size(frames);
else
    [m, n, nFrame] = size(frames);
    nChannel = 1;
end;
    
if ~exist('options', 'var')
    options = [];
end;

options = argutil_setdefaults(options, 'nSample', 1000, 'nIter', 15, 'coverRatiox', 0.5, 'coverRatioy', 0.5, 'magnitudeRatio', 1, 'resizeRatio', 0.25, 'power', 1);

[blockx, blocky] = build_blocks(img, b, options);

estAllPs = zeros(b.nC, nFrame, length(blockx), length(blocky));
if nChannel > 1
    closestPatchesAll = zeros(m, n, nChannel, nFrame);
else
    closestPatchesAll = zeros(m, n, nFrame);
end;
% generated = true;
% if ~exist('samplePsAll', 'var')
%     samplePsAll = cell(length(blockx), length(blocky));
%     sampleImgsAll = cell(length(blockx), length(blocky));
%     sampleImgsSmallAll = cell(length(blockx), length(blocky));
%     generated = false;
% end;

if isfield(optionsPartition, 'xs') && ~isempty(optionsPartition.xs)
    if optionsPartition.xs(1) == -1
        optionsPartition.xs(1) = 1;
    end;
    if optionsPartition.xs(2) == -1
        optionsPartition.xs(2) = length(blockx);
    end;
else
    optionsPartition.xs = [1, length(blockx)];
end;

if isfield(optionsPartition, 'ys') && ~isempty(optionsPartition.ys)
    if optionsPartition.ys(1) == -1
        optionsPartition.ys(1) = 1;
    end;
    if optionsPartition.ys(2) == -1
        optionsPartition.ys(2) = length(blocky);
    end;
else
    optionsPartition.ys = [1, length(blocky)];
end;

for i = optionsPartition.xs(1):optionsPartition.xs(2)
    for j = optionsPartition.ys(1):optionsPartition.ys(2)
        fprintf(1, 'block x(%d/%d, this:%d/%d), block y(%d/%d, this:%d/%d)...\n', i, length(blockx), optionsPartition.xs(1), optionsPartition.xs(2), j, length(blocky), optionsPartition.ys(1), optionsPartition.ys(2));
        xsel = blockx(i):blockx(i)+b.w-1;
        ysel = blocky(j):blocky(j)+b.h-1;
        
%        if ~generated
        % then generate samples and do pose estimation for each frame. 
        bbox = [xsel(1), ysel(1), xsel(end), ysel(end)];
        [samplePs, sampleImgs] = nnpull_genSamplesRegion(img, bbox, b, options.nSample, options.magnitudeRatio, options.power, options.resizeRatio);
        % properly downsampling
%        end;
        if nChannel > 1
            [rectifieds, estPs, closestPatches] = nnpull_poseEst(img, bbox, frames(ysel, xsel, :, :), sampleImgs, samplePs, b, options);
            closestPatchesAll(ysel, xsel, :, :) = closestPatches;
        else
            [rectifieds, estPs, closestPatches] = nnpull_poseEst(img, bbox, frames(ysel, xsel, :), sampleImgs, samplePs, b, options);
            closestPatchesAll(ysel, xsel, :) = closestPatches;
        end;

        estAllPs(:, :, i, j) = estPs;
    end;
end;
