function [rectifieds, wx, wy] = exp_recon(imgs, mWarp, nWarp, blockx, blocky, bFine, estAllPs, usingforward)
[m, n, nFrame] = size(imgs);
[wx, wy] = util_rectify(mWarp, nWarp, blockx, blocky, bFine, estAllPs);
% if size of imgs are different than wx and wy, then do upsampling
if m ~= mWarp || n ~= nWarp
    wx = imresize(wx * (n / nWarp), [m, n]);
    wy = imresize(wy * (m / mWarp), [m, n]);
end;
if ~exist('usingforward', 'var') || ~usingforward
    [meanImg, rectifieds] = warp_pullback(imgs, wx, wy);
else
    % blur and reconstruct.
    gf = fspecial('gaussian', [5, 5], 2);
    wx = imfilter(wx, gf, 'same');
    wy = imfilter(wy, gf, 'same');
    [iwx, iwy] = warp_inverse(wx, wy);
    clear wx wy;
    
    rectifieds = warp_simulateXY(imgs, iwx, iwy);
end;