% journal_exp_water
%%
optionsSamp.nSample = 10000;
optionsSamp.nIter = 15;
optionsSamp.power = 2;
optionsSamp.magnitudeRatio = 1;
optionsSamp.func = @ms_l1; 
optionsSamp.coverRatiox = 0.5;
optionsSamp.coverRatioy = 0.5;

optionsPartition.xfrac = 3;
optionsPartition.yfrac = 3;

switch dataset
  case 1
    datafilename = 'tinyFonts2data.mat';
  case 2
    datafilename = 'smallFonts2data.mat';
  case 3
    datafilename = 'middleFonts2data.mat';
end;

fprintf(1, ['load ' datafilename '\n']);
eval(['load ' datafilename]);

load bWater.mat;

parallel = true;

% it is quite slow...
% if you have several cores in your computer, then you can run each patch in parallel.
if ~parallel
    optionsPartition.xs = [1 -1];
    optionsPartition.ys = [1 -1];
else
    [blockx, blocky] = build_blocks(img, b, optionsSamp);
    nbx = length(blockx);
    nby = length(blocky);

    switch index
      case 1
        optionsPartition.xs = [1, floor(nbx/2)];
        optionsPartition.ys = [1, floor(nby/2)];
      case 2
        optionsPartition.xs = [floor(nbx/2)+1, nbx];
        optionsPartition.ys = [1, floor(nby/2)];
      case 3
        optionsPartition.xs = [1, floor(nbx/2)];
        optionsPartition.ys = [floor(nby/2)+1, nby];
      case 4
        optionsPartition.xs = [floor(nbx/2)+1, nbx];
        optionsPartition.ys = [floor(nby/2)+1, nby];    
    end;
end;
   

%% run the algorithm...
[blockx, blocky, estAllPs] = exp_multistage_2(img, frames, optionsPartition, optionsSamp, b);

%% get the dense deformation field 
% rectifications are the rectified video sequences..
[rectifications] = exp_recon(frames, size(frames, 1), size(frames, 2), blockx, blocky, ...
                             b, estAllPs, true);

% wx and wy is the estimated dense warping fields...
[wx, wy] = util_rectify(size(frames, 1), size(frames, 2), blockx, blocky, b, estAllPs);
