function [esty, allindices, measures] = ml_knnreg(xtrain, ytrain, xtest, options)
% options is medatory, 
% options.K, options.func, options.sigma and options.isWeighted is medatory.
% options.functype specifies the type of function, it could be 'dist' or 'sim'
% in the case of similarity, option.sigma is of no use. 

[nDim1, nTrain] = size(xtrain);
[nDim2, nTest] = size(xtest);

nYdim = size(ytrain, 1);
esty = zeros(nYdim, nTest);
allindices = zeros(options.K, nTest);
measures = zeros(options.K, nTest);

for i = 1:nTest
    measure = zeros(nTrain, 1);
    for j = 1:nTrain
        measure(j) = feval(options.func, xtrain(:, j), xtest(:, i));
    end;
    if strcmp(options.functype, 'dist') 
        [sortedMeasure, indices] = sort(measure);
        if options.isWeighted
            sel_measure = sortedMeasure(1:options.K) - sortedMeasure(1);
            weights = exp(- sel_measure / options.sigma);
            weights = weights ./ sum(weights);
        else
            weights = repmat(1.0 / options.K, options.K, 1);
        end;
    else % similarity, should be positive
        [sortedMeasure, indices] = sort(measure, 'descend');
        if options.isWeighted
            weights = sortedMeasure(1:options.K);
            weights = weights ./ sum(weights);
        else
            weights = repmat(1.0 / options.K, options.K, 1);
        end;
    end;
    % then do regression
    esty(:, i) = ytrain(:, indices(1:options.K)) * weights;
    allindices(:, i) = indices(1:options.K);
    measures(:, i) = sortedMeasure(1:options.K);
end;