function [samplePs, sampleImgs] = nnpull_genSamplesRegion(img, bbox, b, nTrain, ratio, power, imageRatio, wx, wy)
nChannel = size(img, 3);
samplePs = nnpull_genPs(b, nTrain, ratio, power);
[sx, sy] = bb_getsize(bbox);
wSmall = round(sx * imageRatio);
hSmall = round(sy * imageRatio);
if nChannel > 1
    sampleImgs = zeros(hSmall, wSmall, nChannel, nTrain); 
else
    sampleImgs = zeros(hSmall, wSmall, nTrain); 
end;

base_warping = false;
if exist('wx', 'var') && exist('wy', 'var')
    base_warping = true;
end;

for i = 1:nTrain
    [thisWx, thisWy] = warp_recon(b, samplePs(:, i));
    if base_warping
        generated = warp_simulate_region(img, bbox, thisWx + wx, thisWy + wy);
    else
        generated = warp_simulate_region(img, bbox, thisWx, thisWy);
    end;
    
    if nChannel > 1
        sampleImgs(:, :, :, i) = imresize(generated, [hSmall, wSmall]);
    else
        sampleImgs(:, :, i) = imresize(generated, [hSmall, wSmall]);
    end;
end;
%sampleImgs = reshape(sampleImgs, w*h, nTrain);
    
