function [rectifieds, estDeforms, rectSteps] = nnpull_local_poseEst(imgs, sampleImgs, samplesPs, b, wseq, hseq, intensityshift, nIter)
kNN = 10;
sigma = 5;

[m, n, nFrame] = size(imgs);
rectifieds = zeros(m, n, nFrame);
estDeforms.Xs = zeros(m, n, nFrame);
estDeforms.Ys = zeros(m, n, nFrame);

recordEachStep = false;

if nargout >= 3
    rectSteps = zeros(m, n, nIter+1, nFrame);
    recordEachStep = true;
end;

wlen = length(wseq);
hlen = length(hseq);

for i = 1:nFrame
    fprintf(1, 'Deal with image #%d...', i);
    rectified = imgs(:, :, i) - intensityshift;
    for k = 1:nIter
        if recordEachStep
            rectSteps(:, :, k, i) = rectified + intensityshift;
        end;
        
        weights = repmat(1e-8, m, n);
        
        for ii = 1:wlen
            for jj = 1:hlen
                hsel = hseq(jj):hseq(jj) + b.h - 1;
                wsel = wseq(ii):wseq(ii) + b.w - 1;
                rectifiedBlock = rectified(hsel, wsel);
                
                [p, indices] = ml_knnreg(sampleImgs{jj, ii} - intensityshift, samplesPs{jj, ii}, rectifiedBlock(:), kNN, @ms_l2, sigma);
                [wx, wy] = warp_recon(b, p);
                
                estDeforms.Xs(hsel, wsel, i) = estDeforms.Xs(hsel, wsel, i) + wx;
                estDeforms.Ys(hsel, wsel, i) = estDeforms.Ys(hsel, wsel, i) + wy;
                weights(hsel, wsel) = weights(hsel, wsel) + 1;
            end;
        end;
        estDeforms.Xs = estDeforms.Xs ./ weights;
        estDeforms.Ys = estDeforms.Ys ./ weights;        
        
        [means, rectified] = warp_pullback(imgs(:, :, i), estDeforms.Xs(:, :, i), estDeforms.Ys(:, :, i));
    end;
    if recordEachStep
        rectSteps(:, :, nIter+1, i) = rectified + intensityshift;
    end;
    rectifieds(:, :, i) = rectified + intensityshift;
    fprintf(1, '\n');
end;