function [rectifieds, estPs] = nnpull_poseEstFeature(img, bbox, imgs, ...%sampleDts, 
    sampleBins, nBin, samplesPs, b, options)
[nP, nTrain] = size(samplesPs);

% [mSmall, nSmall, nBin, nTrain] = size(sampleDts);
[mSmall, nSmall, nTrain] = size(sampleBins);

[m, n, nFrame] = size(imgs);
rectifieds = zeros(m, n, nFrame);

errs = zeros(options.nIter, 1);

estPs = zeros(b.nC, nFrame);
psEachStep = zeros(b.nC, options.nIter, nFrame);

for i = 1:nFrame
    fprintf(1, 'Deal with image #%d...', i);
    rectified = imgs(:, :, i);
    w = ones(size(rectified));
    ps = zeros(b.nC, 1);
    
    errs(:) = inf;
    
    for k = 1:options.nIter
        % find nn
    %    feature = ext_v1(rectified, [], 1, 8, 8, 1.0);
        if mSmall ~= m || nSmall ~= n
            rectified = imresize(rectified, [mSmall, nSmall]);
            w = imresize(w, [mSmall, nSmall]);
        end;
        bin = match_extract_feature(rectified, nBin, options.thres);
        %indices = find(bin ~= 0);
        %[Yr, Xr] = ind2sub([nSmall, mSmall], indices);
        %types = bin(indices);
        
        dists = zeros(nTrain, 1);
        for j = 1:nTrain
            %dists(j) = match_compute_distance(Xr, Yr, types, sampleDts(:, :, :, j));
            thisSample = sampleBins(:, :, j);
            dists(j) = sum(bin(w(:) > 0.5) - thisSample(w(:) > 0.5) ~= 0);
        end;
        
        [minDists, minIndices] = sort(dists);
        % now just average
        currEstP = mean(samplesPs(:, minIndices(1:options.K)), 2); 
        
        ps = ps + currEstP;
        [wx, wy] = warp_recon(b, ps);
        [means, rectified, w] = warp_pullback(imgs(:, :, i), wx, wy);
        % verify it. 
        simulated = warp_simulateb_region(img, bbox, b, ps);
        errs(k) = sum(colize(simulated - imgs(:, :, i)).^2);
        psEachStep(:, k, i) = ps;
        
        if isfield(options, 'riseStop') && options.riseStop
            if k > 1 && errs(k) > errs(k - 1)
                break;
            end;
        end;
    end;
    % find the best iteration
    [minErr, minIter] = min(errs);
    %minIter = options.nIter;
    ps = psEachStep(:, minIter, i);
    [wx, wy] = warp_recon(b, ps);
    fprintf(1, 'minIter = %d', minIter);
    
    [means, rectified] = warp_pullback(imgs(:, :, i), wx, wy);
    
    rectifieds(:, :, i) = rectified;
    estPs(:, i) = ps;
    if isfield(options, 'temporal') && options.temporal
        fprintf(1, '   *** new sample added...');
        % put a new sample into this set
        samplesPs = cat(2, samplesPs, ps);
        sampleImgs = cat(3, sampleImgs, imresize(warp_simulateb_region(img, bbox, b, ps), [mSmall, nSmall]));
        nTrain = nTrain + 1;
    end;
    
    fprintf(1, '\n');
end;