function [rectifieds, estPs, rectSteps] = nnpull_resample_poseEst(sourceImg, imgs, sampleImgs, samplesPs, b, nIter)
[nP, nTrain] = size(samplesPs);
kNN = 10;
sigma = 5;

[m, n, nFrame] = size(imgs);
rectifieds = zeros(m, n, nFrame);
estPs = zeros(b.nC, nFrame);

recordEachStep = false;

if nargout >= 3
    rectSteps = zeros(m, n, nIter+1, nFrame);
    recordEachStep = true;
end;

resampleN = 5000;

for i = 1:nFrame
    fprintf(1, 'Deal with image #%d...', i);
    rectified = imgs(:, :, i);
    for k = 1:nIter
        if recordEachStep
            rectSteps(:, :, k, i) = rectified;
        end;
        [currEstP, indices] = ml_knnreg(sampleImgs, samplesPs, rectified(:), kNN, @ms_l2, sigma);
        estPs(:, i) = estPs(:, i) + currEstP;
        [means, rectified] = warp_pullback(imgs(:, :, i), b, estPs(:, i));
    end;
    
    [sampleImgsRe, samplesPsRe] = resample(sourceImg, rectified, b, resampleN);
    sampleImgsRe = reshape(sampleImgsRe, [m*n, resampleN]);
    
    for k = 1:nIter
        [currEstP, indices] = ml_knnreg(sampleImgsRe, samplesPsRe, rectified(:), kNN, @ms_l2, sigma);
        estPs(:, i) = estPs(:, i) + currEstP;
        [means, rectified] = warp_pullback(imgs(:, :, i), b, estPs(:, i));
    end;
    
    if recordEachStep
        rectSteps(:, :, nIter+1, i) = rectified;
    end;
    rectifieds(:, :, i) = rectified;
    fprintf(1, '\n');
end;
