function [warpX, warpY] = util_rectify(m, n, blockx, blocky, b, estAllPs)
nFrame = size(estAllPs, 2);

gf = fspecial('gaussian', [5, 5], 1);
warpX = zeros(m, n, nFrame);
warpY = zeros(m, n, nFrame);
counter = zeros(m, n);

for i = 1:length(blockx)
    for j = 1:length(blocky)
        xsel = blockx(i):blockx(i)+b.w-1;
        ysel = blocky(j):blocky(j)+b.h-1;

        [wx, wy] = warp_recon(b, estAllPs(:, :, i, j));
        warpX(ysel, xsel, :) = warpX(ysel, xsel, :) + wx;
        warpY(ysel, xsel, :) = warpY(ysel, xsel, :) + wy;
        counter(ysel, xsel) = counter(ysel, xsel) + 1;
    end;
end;

for i = 1:nFrame
    warpX(:, :, i) = imfilter(warpX(:, :, i) ./ (counter + 1e-8), gf, 'same');
    warpY(:, :, i) = imfilter(warpY(:, :, i) ./ (counter + 1e-8), gf, 'same');
end;
