function [wx, wy] = warp_composition(wx1, wy1, wx2, wy2)
% find the final warping by first warp the image using wx1, wy1, then warp
% the image using wx2, wy2;
% warp_simulate(img, wx, wy) = warp_simulate(warp_simulate(img, wx2, wy2), wx1, wy1)
[m, n, nFrame] = size(wx1);
[X, Y] = meshgrid(1:n, 1:m);

wx = zeros(m, n, nFrame);
wy = zeros(m, n, nFrame);

for i = 1:nFrame
    Xnew = reshape(X + wx1(:, :, i), m*n, 1);
    Ynew = reshape(Y + wy1(:, :, i), m*n, 1);
       
    valid = (Xnew >= 1) & (Xnew <= n) & (Ynew >= 1) & (Ynew <= m);
    
    Xnew(Xnew < 1) = 1;
    Xnew(Xnew > n) = n;
    Ynew(Ynew < 1) = 1;
    Ynew(Ynew > m) = m;
    
    Xnew2 = Xnew;
    Ynew2 = Ynew;
    
    Xnew2(valid) = interp2(wx2(:, :, i), Xnew(valid), Ynew(valid)) + Xnew(valid);
    Ynew2(valid) = interp2(wy2(:, :, i), Xnew(valid), Ynew(valid)) + Ynew(valid);

    wx(:, :, i) = reshape(Xnew2, m, n) - X;
    wy(:, :, i) = reshape(Ynew2, m, n) - Y;
end;
