function [b, variances, coeffs] = warp_createBases(warp, nC, selector)
if nargin < 3
    selector = 1:warp.nFrame;
end;

h = warp.h;
w = warp.w;

data = [reshape(warp.Xs(:, :, selector), h * w, length(selector)); ...
        reshape(warp.Ys(:, :, selector), h * w, length(selector))];
       
[bases, variances, coeffs] = ml_pca(data, nC);
b.b = bases;
b.bx = bases(1:h*w, :);
b.by = bases(h*w+1:end, :);
b.variances = variances;

% bx2 = reshape(b.bx, [h, w, nC]);
% by2 = reshape(b.by, [h, w, nC]);
% 
% b.bxx = zeros(h*w, nC);
% b.bxy = zeros(h*w, nC);
% b.byx = zeros(h*w, nC);
% b.byy = zeros(h*w, nC);
% 
% b.lap_b = zeros(2*h*w, nC);
% 
% for i = 1:nC
%     [bxx, bxy] = gradient(bx2(:, :, i));
%     [byx, byy] = gradient(by2(:, :, i));
%     
%     [bxxx, bxxy] = gradient(bxx);
%     [byyx, byyy] = gradient(byy);
%     
%     b.bxx(:, i) = reshape(bxx, h*w, 1);
%     b.bxy(:, i) = reshape(bxy, h*w, 1);
%     b.byx(:, i) = reshape(byx, h*w, 1);
%     b.byy(:, i) = reshape(byy, h*w, 1);
%     
%     b.lap_b(:, i) = [reshape(bxxx + byyx, h*w, 1); reshape(bxxy + byyy, h*w, 1)];
% end;
% 
% b.L = b.b' * b.lap_b;

b.w = w;
b.h = h;
b.nC = nC;