function b = warp_createLens(h, w, variances)
b.w = w;
b.h = h;
b.nC = 6;

b.bx = zeros(h*w, b.nC);
b.by = zeros(h*w, b.nC);
b.variances = variances;

[X, Y] = meshgrid(1:w, 1:h);
X = X(:);
Y = Y(:);

X = ml_normalize(X);
Y = ml_normalize(Y);
R = sqrt(X.^2 + Y.^2);

b.bx(:, 1) = X;
b.by(:, 1) = Y;

b.bx(:, 2) = R.*X;
b.by(:, 2) = R.*Y;

b.bx(:, 3) = R.^2.*X;
b.by(:, 3) = R.^2.*Y;

b.bx(:, 4) = R.^3.*X;
b.by(:, 4) = R.^3.*Y;

b.bx(:, 5) = R.^4.*X;
b.by(:, 5) = R.^4.*Y;

b.bx(:, 6) = R.^5.*X;
b.by(:, 6) = R.^5.*Y;
