function b = warp_createMetric(h, w, variances)
b.w = w;
b.h = h;
b.nC = 4;

b.bx = zeros(h*w, b.nC);
b.by = zeros(h*w, b.nC);
b.variances = variances;

[X, Y] = meshgrid(1:w, 1:h);
X = X(:);
Y = Y(:);

X = ml_normalize(X) / sqrt(h*w);
Y = ml_normalize(Y) / sqrt(h*w);

sqrt2 = sqrt(2);

% translation x and y
b.bx(:, 1) = 1 / sqrt(h*w); % x
b.by(:, 2) = 1 / sqrt(h*w); % y
% rotation
b.bx(:, 3) = -Y / sqrt2;
b.by(:, 3) = X / sqrt2;
% scaling
b.bx(:, 4) = X / sqrt2;
b.by(:, 4) = Y / sqrt2;