function b = warp_createQuadratic(h, w, variances)
b.w = w;
b.h = h;
b.nC = 6;

b.bx = zeros(h*w, b.nC);
b.by = zeros(h*w, b.nC);
b.variances = variances;

[X, Y] = meshgrid(1:w, 1:h);
X = X(:);
Y = Y(:);

X = ml_normalize(X) / sqrt(h*w);
Y = ml_normalize(Y) / sqrt(h*w);

b.bx(:, 1) = X.^2;
b.bx(:, 2) = Y.^2;
b.bx(:, 3) = X.*Y;

b.by(:, 4) = X.^2;
b.by(:, 5) = Y.^2;
b.by(:, 6) = X.*Y;