function [iwx, iwy] = warp_inverse(wx, wy)
[m, n, nFrame] = size(wx);
[X, Y] = meshgrid(1:n, 1:m);
iwx = zeros(m, n, nFrame);
iwy = zeros(m, n, nFrame);

thisIwx = zeros(m, n);
thisIwy = zeros(m, n);
w = zeros(m, n);

gf = fspecial('gaussian', [11, 11], 3);

for i = 1:nFrame
    thisWx = wx(:, :, i);
    thisWy = wy(:, :, i);
    newX = X + thisWx;
    newY = Y + thisWy;
    
    valid = (newX >= 1) & (newX <= n) & (newY >= 1) & (newY <= m);
    indices = sub2ind([m, n], round(newY(valid)), round(newX(valid)));
    
    w(:) = 0;
    thisIwx(:) = 0;
    thisIwy(:) = 0;
    
    thisIwx(indices) = -thisWx(valid);
    thisIwy(indices) = -thisWy(valid);
    w(indices) = w(indices) + 1;
    
    w = imfilter(w, gf, 'replicate');
    thisIwx = imfilter(thisIwx, gf, 'replicate');
    thisIwy = imfilter(thisIwy, gf, 'replicate');
    
    eps = 1e-4;
    iwx(:, :, i) = thisIwx ./ (w + eps);
    iwy(:, :, i) = thisIwy ./ (w + eps);
end;