function [p, res] = warp_proj(b, wx, wy)
if isstruct(wx) 
    if exist('wy', 'var')
        index = wy;
    else
        index = 1:wx.nFrame;
    end;
    data = [reshape(wx.Xs(:, :, index), b.h*b.w, length(index)); reshape(wx.Ys(:, :, index), b.h*b.w, length(index))];
else
    nFrame = size(wx, 3);
    data = [reshape(wx, b.h*b.w, nFrame); reshape(wy, b.h*b.w, nFrame)];
end;

if isfield(b, 'isframe') && b.isframe
    p = [b.bx; b.by] \ data;
else
    p = [b.bx; b.by]' * data;
end;

if nargout >= 2
    res = [b.bx; b.by] * p - data;
    res = sqrt(sum(res.^2, 1));
end;