function [warp, levels] = warp_randomWarp(img, nFrame, alpha)
if size(img, 1) > 1 && size(img, 2) > 1
    h = size(img, 1);
    w = size(img, 2);
else
    w = img(1);
    h = img(2);
end;

soby = fspecial('sobel');
sobx = soby';

gSize = ceil(min(w, h) / 2);
warp.Xs = zeros(h, w, nFrame);
warp.Ys = zeros(h, w, nFrame);
levels = zeros(h, w, nFrame);

for i = 1:nFrame
    levels(:, :, i) = warp_init(h, w, gSize);
    warp.Xs(:, :, i) = alpha * imfilter(levels(:, :, i), sobx, 'circular');
    warp.Ys(:, :, i) = alpha * imfilter(levels(:, :, i), soby, 'circular');
end;
warp.h = h;
warp.w = w;
warp.nFrame = nFrame;