function frames = warp_simulateXY(img, warpXs, warpYs)
[h, w, nFrameImg] = size(img);
nFrame = size(warpXs, 3);
frames = zeros(h, w, nFrame);

[X, Y] = meshgrid(1:w, 1:h);
for i = 1:nFrame
    % 
    Xnew = reshape(X + warpXs(:, :, i), h*w, 1);
    Ynew = reshape(Y + warpYs(:, :, i), h*w, 1);

    % this is for blank interpolation
    
    % this is for nearest interpolation
    Xnew(Xnew < 1) = 1;
    Xnew(Xnew > w) = w;
    Ynew(Ynew < 1) = 1;
    Ynew(Ynew > h) = h;
    
    valid = (Xnew >= 1 & Xnew <= w & Ynew >= 1 & Ynew <= h);
    
    currFrame = zeros(h*w, 1);
    if nFrameImg == nFrame
        currFrame(valid) = interp2(img(:, :, i), Xnew(valid), Ynew(valid));
    else
        currFrame(valid) = interp2(img, Xnew(valid), Ynew(valid));
    end;
    frames(:, :, i) = reshape(currFrame, h, w);
end;
