function frames = warp_simulateb(img, b, ps, isShown)
[h, w, nChannel] = size(img);
[firstNC, nFrame] = size(ps);

isShown = exist('isShown', 'var') && isShown;

[X, Y] = meshgrid(1:w, 1:h);
X = X(:);
Y = Y(:);
if nChannel == 1
    frames = zeros(h, w, nFrame);
else
    frames = zeros(h, w, nChannel, nFrame);
end;

for i = 1:nFrame
    % 
    Xnew = X + b.bx(:, 1:firstNC) * ps(:, i);
    Ynew = Y + b.by(:, 1:firstNC) * ps(:, i);
    
    % this is for blank interpolation
    
    % this is for nearest interpolation
%     Xnew(Xnew < 1) = 1;
%     Xnew(Xnew > w) = w;
%     Ynew(Ynew < 1) = 1;
%     Ynew(Ynew > h) = h;
    
    valid = (Xnew >= 1 & Xnew <= w & Ynew >= 1 & Ynew <= h);
    
    imgCurr = zeros(h, w, nChannel);
    currFrame = zeros(h*w, 1);
    for k = 1:nChannel
        currFrame(valid) = interp2(img(:, :, k), Xnew(valid), Ynew(valid));
        imgCurr(:, :, k) = reshape(currFrame, h, w);
    end;

    if isShown
        imshow(imgCurr);
        pause(0.01);
    end;
    if nChannel > 1
        frames(:, :, :, i) = imgCurr;
    else
        frames(:, :, i) = imgCurr;
    end;
end;