function frames = warp_simulateb_region(img, bbox, b, ps, isShown)
[h, w, nChannel] = size(img);
[wBox, hBox] = bb_getsize(bbox);
[firstNC, nFrame] = size(ps);

isShown = exist('isShown', 'var') && isShown;

[X, Y] = meshgrid(bbox(1):bbox(3), bbox(2):bbox(4));
X = X(:);
Y = Y(:);
if nChannel == 1
    frames = zeros(hBox, wBox, nFrame);
else
    frames = zeros(hBox, wBox, nChannel, nFrame);
end;

for i = 1:nFrame
    % 
    Xnew = X + b.bx(:, 1:firstNC) * ps(:, i);
    Ynew = Y + b.by(:, 1:firstNC) * ps(:, i);
    
    % this is for blank interpolation
    
    % this is for nearest interpolation
    Xnew(Xnew < 1) = 1;
    Xnew(Xnew > w) = w;
    Ynew(Ynew < 1) = 1;
    Ynew(Ynew > h) = h;
    
    valid = (Xnew >= 1 & Xnew <= w & Ynew >= 1 & Ynew <= h);
    
    imgCurr = zeros(hBox, wBox, nChannel);
    currFrame = zeros(hBox*wBox, 1);
    for k = 1:nChannel
        currFrame(valid) = interp2(img(:, :, k), Xnew(valid), Ynew(valid));
        imgCurr(:, :, k) = reshape(currFrame, hBox, wBox);
    end;

    if isShown
        imshow(imgCurr);
        pause(0.01);
    end;
    if nChannel > 1
        frames(:, :, :, i) = imgCurr;
    else
        frames(:, :, i) = imgCurr;
    end;
end;