function transCenters = warp_transport(centers, b, ps, lefttop)
if ~exist('lefttop', 'var')
    lefttop = ones(2, 1);
end;

[nFrame] = size(ps, 2);
[nPoint, nDim] = size(centers);

transCenters = zeros(nPoint, nFrame, nDim);
indices = sub2ind([b.h, b.w], centers(:, 2), centers(:, 1)); 

transCenters(:, :, 1) = repmat(centers(:, 1), 1, nFrame) + b.bx(indices, :) * ps + lefttop(1) - 1;
transCenters(:, :, 2) = repmat(centers(:, 2), 1, nFrame) + b.by(indices, :) * ps + lefttop(2) - 1;

transCenters = permute(transCenters, [1, 3, 2]);
